%******************************************************************************
% FILE = local.red 				Sat Jul 30 16:08:37 EDT 1988
%
% Procedures in this file:
% 
% INITREDUCE LITER RLISPMAIN INPRINT OPRIN DIFFP
%
% Copyright (c) 1985 The Rand Corporation;
%
%******************************************************************************

% routines modified for redten. (lifted from alg1.red)

GLOBAL '(OBRKP!* ORIG!* SPARE!* POSN!* !*NAT YCOORD!* YMIN!* YMAX!*
        !*FORT !*LIST STATCOUNTER !*INT DATE!*);
FLUID '(!*USERMODE);

PUT ('TIMES, 'PRTCH, '(" "  "*")); % fort mode * used in oprin for not nat mode
SETPROP ('!#, 'NIL);             % clear left-overs from factor package
PUT ('ORIG!*, 'INITL, 1);

SYMBOLIC PROCEDURE INITREDUCE;
  % Initial declarations for REDUCE
  <<STATCOUNTER := 0;
    SPARE!* := 10;
    !*USERMODE := NIL;
    !*INT := T;
    REMPROP('!*MODE,'VARTYPE);  %until trace package changed
    REMD 'MAIN;
    COPYD('MAIN,'RLISPMAIN);
    DATE!* := BLDMSG("%W, %W","REDUCE 3.2 with tensor system",
     "15-Apr-85")>>;

COPYD ('LITER1, 'LITER);

SYMBOLIC PROCEDURE LITER (U);
  IF U EQ '!# THEN 'T             % turn # into a real char.
  ELSE LITER1 (U);

FLUID '(CURRENTREADMACROINDICATOR!* CURRENTSCANTABLE!* LISPSCANTABLE!*
         RLISPSCANTABLE!*);

SYMBOLIC PROCEDURE RLISPMAIN;
  BEGIN SCALAR L;
    RLISPSCANTABLE!* := MKVECT 128;
    L := '(17 11 11 11 11 11 11 11 11 17 17 11 17 17 11 11 11 11 11 11 11
           11 11 11 11 11 11 11 11 11 11 11 17 14 15 11 11 12 11 11 11 11
           13 11 11 11 20 11 00 01 02 03 04 05 06 07 08 09 13 11 13 11 13
	   11 11 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10
	   10 10 10 10 10 10 10 11 16 11 11 10 11 10 10 10 10 10 10 10 10
	   10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 11 11 11
	   11 11 RLISPDIPTHONG);
    FOR I:=0:128 DO <<PUTV(RLISPSCANTABLE!*,I,CAR L); L := CDR L>>;
PUTV (RLISPSCANTABLE!*, 35, 10);  % make # a regular char
PUTV (RLISPSCANTABLE!*, 63, 10);  % make ? a regular char
    CURRENTREADMACROINDICATOR!* := 'RLISPREADMACRO;
    CURRENTSCANTABLE!* := RLISPSCANTABLE!*;
    ERROUT!* := 1;  % Errors to standard output, not special stream;
    EVAL '(BEGIN);
    CURRENTSCANTABLE!* := LISPSCANTABLE!*; % But Slisp should use same
					 % syntax as RLISP ? ;
    STANDARDLISP()
  END;

SYMBOLIC PROCEDURE INPRINT(OP,P,L);
   BEGIN
	IF GET(OP,'ALT) THEN GO TO A
	 ELSE IF OP EQ 'EXPT AND !*NAT
	   AND FLATSIZEC CAR L+FLATSIZEC CADR L>
		    (LINELENGTH NIL-SPARE!*)-POSN!*
	  THEN TERPRI!* T;   %to avoid breaking exponent over line;
% hook to print indexed objects
IF OP EQ 'RDR THEN <<
  PRINTRDR (L);
  RETURN ('NIL)
>>;
	MAPRINT(CAR L,P);
    A0: L := CDR L;
    A:	IF NULL L THEN RETURN NIL
	 ELSE IF NOT ATOM CAR L AND OP EQ GET!*(CAAR L,'ALT)
	  THEN GO TO B;
	OPRIN OP;
    B:	MAPRINT(CAR L,P);
	IF NOT !*NAT OR NOT OP EQ 'EXPT THEN GO TO A0;
	YCOORD!* := YCOORD!*-1;
	IF YMIN!*>YCOORD!* THEN YMIN!* := YCOORD!*;
	GO TO A0
   END;

SYMBOLIC PROCEDURE OPRIN OP;
   (LAMBDA X;
	 IF NULL X THEN PRIN2!* OP
	  ELSE IF !*FORT THEN PRIN2!* CADR X
	  ELSE IF !*LIST AND OBRKP!* AND OP MEMQ '(PLUS MINUS)
	   THEN BEGIN TERPRI!* T; PRIN2!* CAR X END
	  ELSE IF !*NAT AND OP EQ 'EXPT
	  THEN BEGIN
		YCOORD!* := YCOORD!*+1;
		IF YCOORD!*>YMAX!* THEN YMAX!* := YCOORD!*
	       END
      % added this line to get a '*' when not in natural mode. uses fort symbol
         ELSE IF NOT !*NAT AND OP EQ 'TIMES THEN PRIN2!* CADR X
	 ELSE PRIN2!* CAR X)
      GET(OP,'PRTCH);


%
% This routine is lifted from the Reduce source
%

SYMBOLIC PROCEDURE DIFFP(U,V);
   %U is a standard power, V a kernel.
   %Value is the standard quotient derivative of U wrt V;
   BEGIN SCALAR W,X,Y,Z, LEX; INTEGER N;
	N := CDR U;	%integer power;
	U := CAR U;	%main variable;
	IF U EQUAL V AND (W := 1 ./ 1) THEN GO TO E
	 ELSE IF ATOM U THEN GO TO F
	 %ELSE IF (X := ASSOC(U,DSUBL!*)) AND (X := ATSOC(V,CDR X))
%		AND (W := CDR X) THEN GO TO E	%deriv known;
	     %DSUBL!* not used for now;
	 ELSE IF (NOT ATOM CAR U AND (W:= DIFFF(U,V)))
		  OR (CAR U EQ '!*SQ AND (W:= DIFFSQ(CADR U,V)))
	  THEN GO TO C	%extended kernel found;
	 ELSE IF (X:= GET!*(CAR U,'DFN)) THEN NIL
	 ELSE IF CAR U EQ 'PLUS AND (W:=DIFFSQ(SIMP U,V))
	  THEN GO TO C
% note that both checks are needed else the system will set derivs wrt to
% other vars to 0
         ELSE IF CHECKTYPE (U, 'RDR) OR (CHECKTYPE (U, 'DF) AND 
	                                 CHECKTYPE (MYCADR (U), 'RDR))
                     THEN <<  % hook for indexed objects
	    IF NOT (W := DFRDR (U, V)) THEN RETURN ('NIL ./ 1);
            ELSE GO TO J
         >>
	 ELSE GO TO H;	%unknown derivative;
	Y := X;
	Z := CDR U;
    A:	W := DIFFSQ(SIMP CAR Z,V) . W;
	IF CAAR W AND NULL CAR Y THEN GO TO H;	%unknown deriv;
	Y := CDR Y;
	Z := CDR Z;
	IF Z AND Y THEN GO TO A
	 ELSE IF Z OR Y THEN GO TO H;  %arguments do not match;
	Y := REVERSE W;
	Z := CDR U;
	W := NIL ./ 1;
    B:	%computation of kernel derivative;
	IF CAAR Y
	  THEN W := ADDSQ(MULTSQ(CAR Y,SIMP SUBLA(PAIR(CAAR X,Z),
						   CDAR X)),
			  W);
	X := CDR X;
	Y := CDR Y;
	IF Y THEN GO TO B;
    C:	%save calculated deriv in case it is used again;
	%IF X := ATSOC(U,DSUBL!*) THEN GO TO D
	%ELSE X := U . NIL;
	%DSUBL!* := X . DSUBL!*;
    D:	%RPLACD(X,XADD(V . W,CDR X,NIL,T));
    E:	%allowance for power;
	%first check to see if kernel has weight;
	IF (X := ATSOC(U,WTL!*))
	  THEN W := MULTPQ('K!* TO (-CDR X),W);
	RETURN IF N=1 THEN W ELSE MULTSQ(!*T2Q((U TO (N-1)) .* N),W);
    F:	%check for possible unused substitution rule;
	IF NOT DEPENDS(U,V)
	   AND (NOT (X:= ATSOC(U,POWLIS!*))
		 OR NOT SMEMBER(V,SIMP CADDDR X))
	  THEN RETURN NIL ./ 1;
	W := LIST('DF,U,V);
	GO TO J;
    H:	%final check for possible kernel deriv;
	IF CAR U EQ 'DF
	  THEN IF DEPENDS(CADR U,V)
		 THEN W := 'DF . CADR U . DERAD(V,CDDR U)
		ELSE RETURN NIL ./ 1
	 ELSE IF DEPENDS(U,V) THEN W := LIST('DF,U,V)
	 ELSE RETURN NIL ./ 1;
    J:  W := IF X := OPMTCH W THEN SIMP X ELSE MKSQ(W,1);
	GO TO E
   END;

;END;
